--secure digging wrappers
local function secureDig()
  while turtle.detect() do 
    turtle.dig() 
  end
end
local function secureDigUp()
  while turtle.detectUp() do 
    turtle.digUp() 
  end
end
local function secureDigDown()
  while turtle.detectDown() do 
    turtle.digDown() 
  end
end



--location returning move wrapper
--https://www.youtube.com/watch?v=bZe5J8SVCYQ
local function forward(x, y, z, r)
  if turtle.forward() then
    sleep(1)
    if r == 0 then
      z = z + 1
    elseif r == 1 then
      x = x - 1
    elseif r == 2 then
      z = z - 1
    elseif r == 3 then
      x = x + 1
    end
  end
  return x,y,z,r
end

local function back(x, y, z, r)
  sleep(1)
  if turtle.back() then
    if r == 0 then
      z = z - 1
    elseif r == 1 then
      x = x + 1
    elseif r == 2 then
      z = z + 1
    elseif r == 3 then
      x = x - 1
    end
  end
  return x,y,z,r
end

local function up(y)
  sleep(1)
  if turtle.up() then
    y = y + 1
  end
  return y
end

local function down(y)
  sleep(1)
  if turtle.down() then
    y = y - 1
  end
  return y
end

local function left(r)
  sleep(1)
  if turtle.turnLeft() then
    r = (r-1) % 4
  end
  return r
end

local function right(r)
  sleep(1)
  if turtle.turnRight() then
    r = (r+1) % 4
  end
  return r
end



return
{
  secureDig=secureDig,
  secureDigUp=secureDigUp,
  secureDigDown=secureDigDown,
  forward=forward,
  back=back,
  up=up,
  down=down,
  left=left,
  right=right,
}